<?php
function woo_pd_generate_brands() {

	global $wpdb, $import;

	@ini_set( 'memory_limit', WP_MAX_MEMORY_LIMIT );

	$i = 0;
	$base_brands = array();
	// Check if Brands is empty
	if( !empty( $import->csv_brand ) ) {
		// Check if Brands only contains a single header
		$size = count( $import->csv_brand );
		if( $import->skip_first && $size == 1 ) {
			$import->log .= "<br />" . __( 'No Brands were provided', 'woocommerce-product-importer' );
			return;
		}
		for( ; $i < $size; $i++ ) {
			if( isset( $import->csv_brand[$i] ) && strpos( $import->csv_brand[$i], $import->category_separator ) ) {
				$base_brands_explode = explode( $import->category_separator, $import->csv_brand[$i] );
				for( $j = 0; $j < count( $base_brands_explode ); $j++ )
					$base_brands[] = $base_brands_explode[$j];
			} else {
				if( isset( $import->csv_brand_1[$i] ) && isset( $import->csv_brand_2[$i] ) && isset( $import->csv_brand_3[$i] ) )
					$base_brands[] = $import->csv_brand[$i] . $import->parent_child_delimiter . $import->csv_brand_1[$i] . $import->parent_child_delimiter . $import->csv_brand_2[$i] . $import->parent_child_delimiter . $import->csv_brand_3[$i];
				else if( isset( $import->csv_brand_1[$i] ) && isset( $import->csv_brand_2[$i] ) )
					$base_brands[] = $import->csv_brand[$i] . $import->parent_child_delimiter . $import->csv_brand_1[$i] . $import->parent_child_delimiter . $import->csv_brand_2[$i];
				else if( isset( $import->csv_brand_1[$i] ) )
					$base_brands[] = $import->csv_brand[$i] . $import->parent_child_delimiter . $import->csv_brand_1[$i];
				else if( isset( $import->csv_brand[$i] ) )
					$base_brands[] = $import->csv_brand[$i];
			}
		}
		unset( $size );
		if( $import->skip_first )
			$i = 1;
		else
			$i = 0;
		$term_taxonomy = apply_filters( 'woo_pd_brand_term_taxonomy', 'product_brand' );
		$size = count( $base_brands );
		$include_log = true;
		if( $size > 1000 ) {
			$import->log .= "<br />>>> " . sprintf( __( 'We have just processed and generated so many Brands that we couldn\'t actually show you it in real-time, %d to be precise...', 'woocommerce-product-importer' ), $size );
			$include_log = false;
		}
		for( ; $i < $size; $i++ ) {
			$base_brands_explode = explode( $import->parent_child_delimiter, $base_brands[$i] );
			for( $j = 0; $j < count( $base_brands_explode ); $j++ ) {
				$brand = new stdClass;
				$brand->contents = $base_brands_explode;
				switch( $j ) {

					case '0':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Brand: %s', 'woocommerce-product-importer' ), trim( $brand->contents[0] ) );
						if( !term_exists( trim( $brand->contents[0] ), $term_taxonomy ) )
							$term = wp_insert_term( htmlspecialchars( trim( $brand->contents[0] ) ), $term_taxonomy );
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Brand: %s', 'woocommerce-product-importer' ), trim( $brand->contents[0] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Brand detected: %s', 'woocommerce-product-importer' ), trim( $brand->contents[0] ) );
						}
						break;

					case '1':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Brand: %s > %s', 'woocommerce-product-importer' ), trim( $brand->contents[0] ), trim( $brand->contents[1] ) );
						$brand->brand_parent = get_term_by( 'name', trim( $brand->contents[0] ), $term_taxonomy );
						if( $brand->brand_parent ) {
							if( !term_exists( trim( $brand->contents[1] ), $term_taxonomy, $brand->brand_parent->term_id ) )
								$term = wp_insert_term( htmlspecialchars( trim( $brand->contents[1] ) ), $term_taxonomy, array( 'parent' => $brand->brand_parent->term_id ) );
						}
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Brand: %s', 'woocommerce-product-importer' ), trim( $brand->contents[1] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Brand detected: %s', 'woocommerce-product-importer' ), trim( $brand->contents[1] ) );
						}
						break;

					case '2':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Brand: %s > %s > %s', 'woocommerce-product-importer' ), trim( $brand->contents[0] ), trim( $brand->contents[1] ), trim( $brand->contents[2] ) );
						$brand->brand_root = get_term_by( 'name', htmlspecialchars( trim( $brand->contents[0] ) ), $term_taxonomy );
						if( $brand->brand_root ) {
							$brand_parent_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $brand->brand_root->term_id, htmlspecialchars( trim( $brand->contents[1] ) ), $term_taxonomy );
							$brand->brand_parent = $wpdb->get_var( $brand_parent_sql );
							$wpdb->flush();
						}
						if( $brand->brand_root && $brand->brand_parent ) {
							if( !term_exists( trim( $brand->contents[2] ), $term_taxonomy, $brand->brand_parent ) )
								$term = wp_insert_term( htmlspecialchars( trim( $brand->contents[2] ) ), $term_taxonomy, array( 'parent' => $brand->brand_parent ) );
						}
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Brand: %s', 'woocommerce-product-importer' ), trim( $brand->contents[2] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Brand detected: %s', 'woocommerce-product-importer' ), trim( $brand->contents[2] ) );
						}
						break;

					case '3':
						if( $include_log )
							$import->log .= "<br />>>> " . sprintf( __( 'Brand: %s > %s > %s > %s', 'woocommerce-product-importer' ), trim( $brand->contents[0] ), trim( $brand->contents[1] ), trim( $brand->contents[2] ), trim( $brand->contents[3] ) );
						$brand->brand_root = get_term_by( 'name', htmlspecialchars( trim( $brand->contents[0] ) ), $term_taxonomy );
						if( $brand->brand_root ) {
							$brand_parent_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $brand->brand_root->term_id, htmlspecialchars( trim( $brand->contents[1] ) ), $term_taxonomy );
							$brand->brand_parent = $wpdb->get_var( $brand_parent_sql );
						}
						if( $brand->brand_root && $brand->brand_parent ) {
							$brand_base_sql = $wpdb->prepare( "SELECT terms.`term_id` FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`parent` = %d AND terms.`name` = %s AND term_taxonomy.`taxonomy` = %s LIMIT 1", $brand->brand_parent, htmlspecialchars( trim( $brand->contents[2] ) ), $term_taxonomy );
							$brand->brand_base = $wpdb->get_var( $brand_base_sql );
							$wpdb->flush();
						}
						if( $brand->brand_root && $brand->brand_parent && $brand->brand_base ) {
							if( !term_exists( trim( $brand->contents[3] ), $term_taxonomy, $brand->brand_base ) )
								$term = wp_insert_term( htmlspecialchars( trim( $brand->contents[3] ) ), $term_taxonomy, array( 'parent' => $brand->brand_base ) );
						}
						if( $include_log ) {
							if( isset( $term ) && $term )
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Created Brand: %s', 'woocommerce-product-importer' ), trim( $brand->contents[3] ) );
							else
								$import->log .= "<br />>>>>>> " . sprintf( __( 'Duplicate of Brand detected: %s', 'woocommerce-product-importer' ), trim( $brand->contents[3] ) );
						}
						break;

					default:
						$skipped_brand_size = $j;
						if( $include_log ) {
							$import->log .= "<br />>>> " . sprintf( __( 'Brand: %s', 'woocommerce-product-importer' ), trim( $brand->contents[$j] ) );
							for( $k = 0; $k <= $skipped_brand_size; $k++ )
								$import->log .= trim( $brand->contents[$k] ) . ' > ';
							$import->log = substr( $import->log, 0, -3 );
							$import->log .= "<br />>>>>>> " . sprintf( __( 'Skipped Brand: %s', 'woocommerce-product-importer' ), trim( $brand->contents[$j] ) );
						}
						break;

				}
				unset( $brand, $term );
			}
		}
		unset( $size );
		$import->log .= "<br />" . __( 'Brands have been generated', 'woocommerce-product-importer' );
	} else {
		$import->log .= "<br />" . __( 'No Brands were provided', 'woocommerce-product-importer' );
	}

}

function woo_pd_process_brands() {

	global $wpdb, $product, $import;

	// Brand association
	$product->brand_term_id = array();
	$pid_brands = array();
	if( isset( $product->brand ) ) {
		if( strpos( $product->brand, $import->category_separator ) ) {
			$pid_brands_explode = explode( $import->category_separator, $product->brand );
			$size = count( $pid_brands_explode );
			for( $i = 0; $i < $size; $i++ )
				$pid_brands[] = $pid_brands_explode[$i];
			unset( $pid_brands_explode, $size );
		} else {
			$pid_brands[] = trim( $product->brand );
		}
		$term_taxonomy = apply_filters( 'woo_pd_brand_term_taxonomy', 'product_brand' );
		$db_brands_sql = $wpdb->prepare( "SELECT terms.`term_id` as term_id, terms.`name` as name, term_taxonomy.`parent` as brand_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND term_taxonomy.`taxonomy` = %s", $term_taxonomy );
		$db_brands = $wpdb->get_results( $db_brands_sql );
		$wpdb->flush();
		foreach( $pid_brands as $pid_brand ) {
			$pid_branddata = explode( $import->parent_child_delimiter, $pid_brand );
			$pid_branddata_size = count( $pid_branddata );
			for( $k = 0; $k < $pid_branddata_size; $k++ ) {
				switch( $k ) {

					case '0':
						foreach( $db_brands as $db_brand ) {
							if( ( htmlspecialchars( $pid_branddata[$k] ) == $db_brand->name ) && ( $db_brand->brand_parent == '0' ) ) {
								$product->brand_term_id[] = $db_brand->term_id;
								break;
							}
						}
						break;

					case '1':
						$pid_parent_sql = $wpdb->prepare( "SELECT terms.`term_id` as id, terms.`name`, term_taxonomy.`parent` as brand_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s LIMIT 1", $pid_branddata[$k-1] );
						$pid_parent = $wpdb->get_row( $pid_parent_sql );
						$wpdb->flush();
						if( $pid_parent !== false ) {
							foreach( $db_brands as $db_brand ) {
								if( $pid_parent->id == $db_brand->brand_parent ) {
									if( htmlspecialchars( trim( $pid_branddata[$k] ) ) == $db_brand->name ) {
										$product->brand_term_id[] = $db_brand->term_id;
										break;
									}
								}
							}
						}
						break;

					case '2':
						$pid_root_sql = $wpdb->prepare( "SELECT terms.`term_id` as id, terms.`name`, term_taxonomy.`parent` as brand_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s LIMIT 1", $pid_branddata[$k-2] );
						$pid_root = $wpdb->get_row( $pid_root_sql );
						$wpdb->flush();
						if( $pid_root !== false ) {
							$pid_parent_sql = $wpdb->prepare( "SELECT terms.`term_id` as id, terms.`name`, term_taxonomy.`parent` as brand_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1",$pid_branddata[$k-1], $pid_root->id );
							$pid_parent = $wpdb->get_row( $pid_parent_sql );
							$wpdb->flush();
							if( $pid_parent !== false ) {
								foreach( $db_brands as $db_brand ) {
									if( $pid_parent->id == $db_brand->brand_parent ) {
										if( htmlspecialchars( trim( $pid_branddata[$k] ) ) == $db_brand->name ) {
											$product->brand_term_id[] = $db_brand->term_id;
											break;
										}
									}
								}
							}
						}
						break;

					case '3':
						$pid_root_sql = "SELECT terms.`term_id` as id, terms.`name`, term_taxonomy.`parent` as brand_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s LIMIT 1";
						$pid_root = $wpdb->get_row( $wpdb->prepare( $pid_root_sql, htmlspecialchars( $pid_branddata[$k-3] ) ) );
						$wpdb->flush();
						if( $pid_root !== false ) {
							$pid_parent_sql = $wpdb->prepare( "SELECT terms.`term_id` as id, terms.`name`, term_taxonomy.`parent` as brand_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", htmlspecialchars( $pid_branddata[$k-2] ), $pid_root->id );
							$pid_parent = $wpdb->get_row( $pid_parent_sql );
							$wpdb->flush();
							if( $pid_parent !== false ) {
								$pid_base_sql = $wpdb->prepare( "SELECT terms.`term_id` as id, terms.`name`, term_taxonomy.`parent` as brand_parent FROM `" . $wpdb->terms . "` as terms, `" . $wpdb->term_taxonomy . "` as term_taxonomy WHERE terms.`term_id` = term_taxonomy.`term_id` AND terms.`name` = %s AND term_taxonomy.`parent` = %d LIMIT 1", htmlspecialchars( $pid_branddata[$k-1] ), $pid_parent->id );
								$pid_base = $wpdb->get_row( $pid_base_sql );
								$wpdb->flush();
								if( $pid_base !== false ) {
									foreach( $db_brands as $db_brand ) {
										if( $pid_base->id == $db_brand->brand_parent ) {
											if( htmlspecialchars( trim( $pid_branddata[$k] ) ) == $db_brand->name ) {
												$product->brand_term_id[] = $db_brand->term_id;
												break;
											}
										}
									}
								}
							}
						}
						break;

					default:
						$import->log .= "<br />" . __( 'We can only link Products to Brands up to 3 levels deep', 'woocommerce-product-importer' );
						break;

				}
			}
		}
	}

}

// Return whether the Brands Term Taxonomy is in use
function woo_pd_detect_product_brands() {

	if( 
		woo_pd_detect_import_plugin( 'wc_brands' ) || 
		woo_pd_detect_import_plugin( 'woocommerce_brands' ) || 
		woo_pd_detect_import_plugin( 'yith_brands_pro' ) || 
		taxonomy_exists( apply_filters( 'woo_pd_brand_term_taxonomy', 'product_brand' ) )
	) {
		add_filter( 'woo_pd_brand_term_taxonomy', 'woo_pd_extend_brand_term_taxonomy' );
		return true;
	}

}
?>