var $j = jQuery.noConflict();

$j(function() {

	// This controls the Skip Overview link on the Overview screen
	$j('#skip_overview').click(function(){
		$j('#skip_overview_form').submit();
	});

	// Import upload methods
	$j('input[name=upload_method]').click(function () {
		$j('.upload-method').hide();
		switch($j('input[name=upload_method]:checked').val()) {

			case 'upload':
				$j('#import-products-filters-upload').show();
				break;

			case 'file_path':
				$j('#import-products-filters-file_path').show();
				break;

			case 'url':
				$j('#import-products-filters-url').show();
				break;

			case 'ftp':
				$j('#import-products-filters-ftp').show();
				break;

		}
	});

	// Image filename method
	$j('input[name=image_method]').click(function () {
		$j('#image_filename_method').hide();
		$j('#duplicate_image_method').hide();
		switch($j('input[name=image_method]:checked').val()) {

			case 'csv':
				$j('#image_filename_method').show();
				$j('#duplicate_image_method').show();
				break;

			case 'external':
				$j('#duplicate_image_method').show();
				break;

		}
	});

	// Unselect all field options for this import type
	$j('.unselectall').click(function () {
		$j(this).closest('.widefat').find('option:selected').attr('selected', false);
		$j('.woo_pd_page_options .options .wp-list-table select').change();
	});

	// Unselect the field option linked to this row
	$j('.clear-link').click(function () {
		selected_index = $j(this).attr('data-key');
		$j('#import_field_select-' + selected_index).find('option:selected').attr('selected', false);
		$j('.woo_pd_page_options .options .wp-list-table select').change();
		$j(this).hide();
	});

	$j(document).ready(function() {
		// Upload screen

		// Import upload methods
		var type = $j('input:radio[name=upload_method]:checked').val();
		$j('#file-filters-'+type).trigger('click');

		// Import screen

		// Image filename method
		var image_method = $j('input:radio[name=image_method]:checked').val();
		if( image_method !== undefined ) {
			if( image_method == 'csv' )
				$j('#image_method_csv').trigger('click');
			else
				$j('#image_filename_method').hide();
		}

		// Import field status
		$j('.woo_pd_page_options .options .wp-list-table select').each(function (index, value) {
			var selected_value = $j(this).val();
			if( selected_value ) {
				$j('#import_field_status-' + index).attr('class','completed');
					$j('#import_field_row-' + index + ' a.clear-link').show();
			}
		});

		$j('.woo_pd_page_options .options .wp-list-table select').change(function() {
			var selected_value = $j(this).val();
			selected_index = $j(this).attr('data-key');
			if( selected_index != 'undefined' ) {
				if( selected_value ) {
					$j('#import_field_status-' + selected_index).attr('class','completed');
					$j('#import_field_row-' + selected_index + ' a.clear-link').show();
				} else {
					$j('#import_field_status-' + selected_index).attr('class','on-hold');
					$j('#import_field_row-' + selected_index + ' a.clear-link').hide();
				}
			}
		});

		// Save screen

		// Finish screen
	});

});